using System;
using System.Text;
using System.Collections;

namespace at.jku.ssw.Analyse
{
	/// <summary>
	/// Das ist die Klasse, die die Wurzel des Code-Baumes darstellt, und auch
	/// das Zusammenfassen aller Informationen bernimmt.
	/// </summary>
	public class RootInfo : at.jku.ssw.Analyse.MethodAvgInfo
	{
		public UsingInfo uiUsings;	// speichert die Using-Direktiven dieses Namespaces

		public RootInfo(String sName, int iLine, CodeInfo parent) : base(sName, iLine, parent) {
			uiUsings = new UsingInfo();
		}

		/// <summary>
		/// Der Root-Knoten (representiert die ganze Datei) hat als vollen Namen (und als Namen)
		/// einen leeren String.
		/// </summary>
		public override String getFullName() { return ""; }

		public override void compute() {
			base.compute();
		}

		public override String ToString(String sTab, bool bToDescend) {
			StringBuilder sb = new StringBuilder();
			sb.Append(base.ToString(sTab, bToDescend));
			sb.Append(sTab).AppendFormat("Namespace Count: {0}\n", getCntNamespaces());
			sb.Append(sTab).AppendFormat("Class Count:     {0}\n", getCntClasses());
			sb.Append(sTab).AppendFormat("Field Count:     {0}\n", getCntFields());
			sb.Append(uiUsings.ToString(sTab));
			if (bToDescend)
				sb.Append(base.ToDescend(sTab));
			return sb.ToString();
		}
	}
}
